<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plaiframe Docs Source: file.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plaiframe Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-session.html">session</a></li><li><a href="module-variables.html">variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors-DesignError.html">errors~DesignError</a></li><li><a href="module-game-Game.html">game~Game</a></li><li><a href="module-medley-Log.html">medley~Log</a></li><li><a href="module-medley-Queue.html">medley~Queue</a></li><li><a href="module-mongo-Database.html">mongo~Database</a></li><li><a href="module-mongo-Collection.html">mongo~Collection</a></li><li><a href="module-mongo-Document.html">mongo~Document</a></li><li><a href="module-ne-Database.html">ne~Database</a></li><li><a href="module-ne-Collection.html">ne~Collection</a></li><li><a href="module-ne-Document.html">ne~Document</a></li><li><a href="module-session-Session.html">session~Session</a></li><li><a href="module-variables-Variables.html">variables~Variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="externals.list.html" class="dropdown-toggle" data-toggle="dropdown">Externals<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="external-Object.html">Object</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: file.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* read and write files
*
* @requires fs-extra
* @requires path
* @requires chokidar
* 
* @module file
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

const fs = require('fs-extra')
const chokidar = require("chokidar")
const path = require('path')

/**
* write data to file
*/
function toFile(data, file, create_dirs)
{
	return new Promise(function(resolve, reject) {
		fs.writeFile(file, data, 'utf8', function (err) {
	    if (err) {
	    	log.error(0, "An error occured while writing to "+file+"\n"+err)
	      reject()
	    }
	    log.info(0, file + " saved")
			resolve(file + " saved")
		})
	})
}

/**
* create folder if it doesnt exist
*
* @returns {boolean} true if folder already existed, false if it was created
*/
function mkdir(path) {
	if (!fs.existsSync(path)){
		fs.mkdirSync(path)
		return(false)
	}
	return(true)
}

/**
 * report changes on directory. Uses [chokidar](@link https://github.com/paulmillr/chokidar).
 * 
 * @param {string} path 
 * @param {function} callback 
 */
function watchDir(path, callback) {
	chokidar.watch(path, {ignoreInitial:true, depth:10}).on('all', callback)
}

/**
* remove folder and content
*
*/
function rm(path) {
	if (fs.existsSync(path)) {
		fs.removeSync(path)
		return(true)
	}
	return(false)
}

/**
 * move or rename a file. 
 * @param {string} orig - file to be moved
 * @param {string} dest - move file to destination
 */
function mv(orig, dest) {
	return new Promise((resolve, reject) => {
		if(dest[dest.length-1] == "/") {
			orig_file = orig.substr(orig.lastIndexOf("/")+1)
			dest = dest + orig_file
		}
		fs.rename(orig, dest, err => {
			if (err) return reject(err);
			log.info("file", "moved from " + orig + " to " + dest)
			return resolve()
		})
	})
}

/**
* check if file or folder exists
*
* @returns {boolean} - true if folder/file exists
*/
function exists(path) {
	return fs.existsSync(path)
}

/**
* get a list of all files in a folder (syncronous)
*
* @example
* // returns list of image files
* ls("/path/to/my/pictures", [".jpg",".jpeg",".png"])
* @example
* // returns only directories
* ls("/path", "directories")
*
* @param {string|array} filter - filter "directories" (only directories) or filenames
*
* @returns {array} list of directories and/or filenames
*/
function ls(dir, filter) {
	if(filter == "directories") {
		return fs.readdirSync(dir)
		.filter(name => {
			let p = path.join(dir, name)
			return fs.lstatSync(p).isDirectory()
		})
	} else if(Array.isArray(filter)) {
		let all = fs.readdirSync(dir)
		let show = []
		for(let a of all) {
			filter.forEach(elem => {
				if(a.includes(elem)) {
					show.push(a)
				}
			})
		}
		return show
	} else if(typeof filter === "string") {
		let all = fs.readdirSync(dir)
		let show = []
		for(let a of all) {
			if(a.includes(filter)) {
				show.push(a)
			}
		}
		return show
	}
	return fs.readdirSync(dir)
}


/**
* load json data from file
*/
function loadJSON(filename)
{
	return new Promise(function(resolve, reject) {
		fs.readFile(filename, 'utf8', function (err,data) {
		if (err) {
			log.error(0, "An error occured while reading "+filename+"\n"+err)
			//reject()
		} else {
			try {
				json_data = JSON.parse(data)
				resolve(json_data)
			} catch(e) {
				log.error(0, "An error occured while reading "+filename+"\n"+e)
				//reject()
			}
		}
		});
	});
}

/**
* save json data to file
*/
function saveJSON(data, file) {
	return new Promise(function(resolve, reject) {
		save_data = JSON.stringify(data, null, 2)
		toFile(save_data, file, true)
		.then(function(result) {
			resolve(result)
		})
		.catch(function(error){
			log.error(this.name, error)
			reject(error)
		})
	});
}

module.exports = {
	loadJSON:loadJSON,
	saveJSON:saveJSON,
	mkdir:mkdir,
	watchDir:watchDir,
	exists:exists,
	ls:ls,
	rm:rm,
	mv:mv
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
